/*
----------------------------------------
	ASM.C: MicroEMACS 3.10
----------------------------------------
*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "estruct.h"
#include "etype.h"
#include "edef.h"

/*
========================================
	RCS id ̐ݒ
========================================
*/

__asm("	dc.b	'$Id: asm.c,v 1.12 1996/10/29 15:38:42 sharl Exp $'\n""	even\n");

/*
========================================
	gp֐̒`
========================================
*/

static int inscomment(int, int, int);
static int inscolon(void);
static int wordmatch(void);

/*
========================================
	gpϐ̒`
========================================
*/

typedef struct {
	char *dir;
	unsigned char del;
	unsigned char indent;
} DIRC;

static __pcr__ DIRC directive[] = {
	{"else",	TRUE,	TRUE},
	{"elseif",	TRUE,	TRUE},
	{"endc",	TRUE,	FALSE},
	{"endif",	TRUE,	FALSE},
	{"if",		FALSE,	TRUE},
	{"ifdef",	FALSE,	TRUE},
	{"ifeq",	FALSE,	TRUE},
	{"iff",		FALSE,	TRUE},
	{"ifndef",	FALSE,	TRUE},
	{"ifne",	FALSE,	TRUE},
	{NULL,		FALSE,	FALSE},
};

static __pcr__ int doindent = FALSE;

/*
----------------------------------------
	'*' }
----------------------------------------
*/

int
asm_insaster(int f, int n)
{
	return inscomment(f, n, '*');
}

/*
----------------------------------------
	';' }
----------------------------------------
*/

int
asm_inssemi(int f, int n)
{
	return inscomment(f, n, ';');
}

/*
========================================
	Rg}
========================================
*/
static int
inscomment(int f, int n, int comc)
{
	if (n <= 0) {
		lastflag = 0;
		return (n < 0 ? FALSE : TRUE);
	} else {
		thisflag = 0;
		if (check_over())
			forwdel(FALSE, 1);
		{
			int i;
			WINDOW *wp = curwp;

			if (wp->w_doto == 0)
				return linsert(1, comc);

			for (i = wp->w_doto - 1; i >= 0; --i) {
				int ch;

				ch = lgetc(wp->w_dotp, i);
				if (ch == 0x40 && lgetc(wp->w_dotp, i - 1) == 0x81)
					i--;
				else if (ch != ' ' && ch != TAB)
					return linsert(1, comc);
			}

			while (getccol(FALSE) >= 1)
				backdel(FALSE, 1);

			return linsert(1, comc);
		}
	}
}

/*
----------------------------------------
	':' }
----------------------------------------
*/

int
asm_inscolon(int f, int n)
{
	if (n <= 0) {
		lastflag = 0;
		return (n < 0 ? FALSE : TRUE);
	} else {
		thisflag = 0;
		if (check_over())
			forwdel(FALSE, 1);
		return inscolon();
	}
}

/*
========================================
	':' }
========================================
*/

static int
inscolon()
{
	int i, curcol;
	WINDOW *wp = curwp;

	if (wp->w_doto == 0)
		return linsert(1, ':');

	curcol = wp->w_doto;
	gotoeol(FALSE, 1);
	if (curcol != wp->w_doto) {
		wp->w_doto = curcol;
		return linsert(1, ':');
	}

	for (i = wp->w_doto - 1; i >= 0; --i) {
		int ch;

		ch = lgetc(wp->w_dotp, i);
		if (ch == 0x40 && lgetc(wp->w_dotp, i - 1) == 0x81)
			i--;
		else if (ch == ' ' || ch == TAB)
			break;
	}

	for (; i >= 0; --i) {
		int ch;

		ch = lgetc(wp->w_dotp, i);
		if (ch == 0x40 && lgetc(wp->w_dotp, i - 1) == 0x81)
			i--;
		else if (ch != ' ' && ch != TAB)
			return linsert(1, ':');
	}

	gotobol(FALSE, 1);
	while (isspace(lgetc(wp->w_dotp, 0)))
		forwdel(FALSE, 1);
	gotoeol(FALSE, 1);
	return linsert(1, ':');
}

/*
----------------------------------------
	asm-newline
----------------------------------------
*/

int
asm_newline(int f, int n)
{
	int flag = FALSE, status;
	WINDOW *wp = curwp;

	if (lgetc(wp->w_dotp, wp->w_doto - 1) == ':')
		flag = TRUE;
	else if (asm_indent)
		flag = wordmatch() && doindent ? TRUE : FALSE;
	status = c_newline(f, n);
	if (flag)
		return tab(FALSE, 1);
	return status;
}

/*
----------------------------------------
	^߃Cfg
----------------------------------------
*/

static int
wordmatch()
{
	int i, status = FALSE;
	WINDOW *wp = curwp;
	int ccol;
	char *str;

	ccol = wp->w_doto;
	for (i = 0; i < wp->w_doto; i++) {
		int ch;

		ch = lgetc(wp->w_dotp, i);
		if (ch != ' ' && ch != TAB)
			break;
	}
	wp->w_doto = i;
	str = getword();

	{
		DIRC *p;

		for (p = directive; p->dir; p++) {
			if (!stricmp(p->dir, *str == '.' ? str + 1 : str)) {
				if (p->del && wp->w_doto != 0)
					backdel(FALSE, 1);
				doindent = p->indent;
				status = TRUE;
				break;
			}
		}
	}
	if (status == FALSE)
		wp->w_doto = ccol;
	else
		gotoeol(FALSE, 1);
	return status;
}
