/*
 * dyna.h -- Iɑ傫Ȃobt@
 * Copyright (C) 1991-1993 by candy
 */
/*
 * $Id: dyna.h,v 1.3 1994/08/11 11:27:28 sharl Exp $
 */
#ifndef __DYNA_H /* [ */
#define __DYNA_H

/*
 * NAME
 * 	STRUCT_DYNA - \̂̐錾(̈ꕔII)
 *
 * SYNOPSIS
 * 	struct DYNA STRUCT_DYNA(TYPE);
 *
 * DESCRIPTION
 * 	TYPE ^vfƂ铮Iɑ傫Ȃz\
 * 		struct DYNA
 * 	錾܂B
 *
 * EXAPMLE
 * 	struct CHAR_BUF STRUCT_DYNA(char);  obt@
 * 	struct LIST_BUF STRUCT_DYNA(char *);  ̃Xg
 * 	̂悤ɐ錾܂B
 * 	TYPE ̏ɂ͐āA`
 * 		TYPE * identifier;
 * 	ɂāAidentifier  TYPE ւ̃|C^ƂȂ悤Ȃ̂܂B
 * 	Ⴆ
 * 		STRUCT_DYNA(char **) ͂
 * 		STRUCT_DYNA(int (*)()) ͂߂łB
 */
#define STRUCT_DYNA(TYPE) \
	{ \
	unsigned int more, size, used; \
	TYPE *buf; \
	TYPE *spare; \
	}

/*
 * NAME
 * 	DYNA_IZ - \̂̏
 *
 * SYNOPSIS
 * 	void DYNA_IZ(struct DYNA *dyna, unsigned int nmore);
 *
 * DESCRIPTION
 * 	\̂܂B
 * 	dyna ɂ STRUCT_DYNA Ő錾\̂̃AhX^܂B
 * 	nmore ɂ͈xɑvf̐w肵܂B
 *
 * EXAMPLE
 * 	struct LIST_BUF STRUCT_DYNA(char *) list_buf;
 * 	̎A
 * 	DYNA_IZ(&list_buf, 64);
 * 	̂悤ɏ܂B
 */
#define DYNA_IZ(dyna, nmore) ((void)( \
	(dyna)->more = (nmore), \
	(dyna)->used = (dyna)->size = 0, \
	(dyna)->buf = (void *)0 \
	))

/*
 * NAME
 * 	DYNA_BRK - z̊g
 *
 * SYNOPSIS
 * 	TYPE *DYNA_BRK(struct DYNA *dyna, unsigned int nmore);
 *
 * DESCRIPTION
 * 	\̂̔z nmore g債܂B
 * 	DYNA_NEXT() IɎŝŕʂ͊֌W܂B
 * 	Ȃ NULL ȊOԂAsȂ NULL Ԃ܂B
 *
 * EXAMPLE
 * 	struct LIST_BUF STRUCT_DYNA(char *) list_buf;
 * 	DYNA_IZ(&list_buf, 64);
 * 	̎A
 * 	if (DYNA_BRK(&list_buf, 16) == NULL)
 * 		goto no_memory;
 * 	ȂǂƂ܂B
 */
#define DYNA_BRK(dyna, nmore) ( \
	(dyna)->spare = (dyna)->buf, \
	(dyna)->size += (nmore), \
	(dyna)->buf = realloc((dyna)->buf, (dyna)->size * sizeof((dyna)->buf[0])), \
	(((dyna)->buf != (void *)0) ? (dyna)->buf \
	: ((dyna)->buf = (dyna)->spare, \
		(dyna)->size -= (nmore), \
		(void *)0)) \
	)

/*
 * NAME
 * 	DYNA_NEXT - obt@̊g
 *
 * SYNOPSIS
 * 	TYPE *DYNA_NEXT(struct DYNA *dyna);
 *
 * DESCRIPTION
 * 	z̐Vvf̃AhXԂ܂B
 * 	gp̈悪 1 ܂B
 * 	Ȃꍇ DYNA_BRK() Ăяo܂B
 * 	sȂ NULL Ԃ܂B
 *
 * EXAMPLE
 * 	struct LIST_BUF STRUCT_DYNA(char *)list_buf;
 * 	char **next;
 * 	DYNA_IZ(&list_buf, 64);
 * 	̎A
 * 	if ((next = DYNA_NEXT(&list_buf)) == NULL)
 * 		goto no_memory;
 * 	*next = malloc(256);
 * 	ȂǂƂ܂B
 */
#define DYNA_NEXT(dyna) ( \
	((dyna)->used >= (dyna)->size && DYNA_BRK(dyna, (dyna)->more) == (void *)0) \
	? (void *)0 \
	: (dyna)->buf + (dyna)->used++ \
	)

/*
 * NAME
 * 	DYNA_ALLOC - obt@̊g
 *
 * SYNOPSIS
 * 	TYPE *DYNA_ALLOC(struct DYNA *dyna, unsigned int n);
 *
 * DESCRIPTION
 * 	z̒̐V n ̘Avf̃AhXԂ܂B
 * 	gp̈悪 n ܂B
 * 	Ȃꍇ DYNA_BRK() Ăяo܂B
 * 	sȂ NULL Ԃ܂B
 *
 * EXAMPLE
 * 	struct CHAR_BUF STRUCT_DYNA(char) char_buf;
 * 	char *next;
 * 	DYNA_IZ(&char_buf, 256);
 * 	̎A
 * 	if ((next = DYNA_ALLOC(&char_buf, strlen(s) + 1)) == NULL)
 * 		goto no_memory;
 * 	strcpy(next, s);
 * ȂǂƂ܂B
 */
#define DYNA_ALLOC(dyna, nmore) ( \
	((dyna)->used + (nmore) > (dyna)->size && DYNA_BRK(dyna, (dyna)->more + (nmore)) == (void *)0) \
	? ((void *)0)\
	: ((dyna)->used += (nmore), (dyna)->buf + (dyna)->used - (nmore))\
	)

/*
 * NAME
 * 	DYNA_RESET - obt@ɂ
 *
 * SYNOPSIS
 * 	void DYNA_RESET(struct DYNA *dyna)
 *
 * DESCRIPTION
 * 	obt@ɂ܂(gp̈ 0 ɂ܂)B
 * 	dyna ɂ STRUCT_DYNA Ő錾\̂̃AhX^܂B
 */
#define DYNA_RESET(dyna) ((void)((dyna)->used = 0))

/*
 * NAME
 * 	DYNA_UNGROW - obt@̏k
 *
 * SYNOPSIS
 * 	void DYNA_UNGROW(struct DYNA *dyna, unsigned int n);
 *
 * DESCRIPTION
 * 	obt@̑傫(gp̈) 0 łȂ΁An vfk܂B
 *
 */
#define DYNA_UNGROW(dyna, n) ((void)((dyna)->used > (n) ? (dyna)->used -= (n) : (dyna)->used = 0))

/*
 * NAME
 * 	DYNA_BUF - obt@̃AhX
 *
 * SYNOPSIS
 * 	TYPE *DYNA_BUF(struct DYNA *dyna);
 *
 * DESCRIPTION
 * 	obt@̍ŏ̗vf̃AhXԂ܂B
 * 	DYNA_BRK()  DYNA_NEXT() ɂĒlω܂̂ŁA
 * 	Ăяo͈ȑO̒l͖ɂȂ܂B
 */
#define DYNA_BUF(dyna) ((dyna)->buf)

/*
 * NAME
 * 	DYNA_USED - obt@̑傫
 *
 * SYNOPSIS
 * 	unsigned int DYNA_USED(struct DYNA *dyna);
 *
 * DESCRIPTION
 * 	obt@̑傫Ԃ܂B
 * 	DYNA_IZ()  0 ŁA
 * 	DYNA_NEXT() 閈 + 1 ܂B
 */
#define DYNA_USED(dyna) ((dyna)->used)

#endif /* ] !__DYNA_H */
