/*
----------------------------------------
	ENVHASH.C: MicroEMACS 3.10
----------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "estruct.h"
#include "etype.h"
#include "edef.h"
#include "evar.h"

/*
========================================
	RCS id ̐ݒ
========================================
*/

__asm("	dc.b	'$Id: envhash.c,v 1.1.2.16 1996/10/13 07:06:52 sharl Exp $'\n""	even\n");

/*
========================================
	֐e[u
========================================
*/

#define NHASH	128

static UVAR *uvar_head[NHASH];
static UENVAR *env_head[NHASH];

UENVAR env_table[] = {
#ifdef B_ACOUNT
	{NULL,	"acount",				EVACOUNT,			0},
#else
	{NULL,	"acount",				EVACOUNT,			&gacount},
#endif
#ifndef MINES
	{NULL,	"add-eof",				EVADDEOF,			&addeof},
#endif
	{NULL,	"asave",				EVASAVE,			&gasave},
#ifdef B_ASAVEHOOK
	{NULL,	"asavehook",			EVASAVEHOOK,		0},
#endif
	{NULL,	"asm-indent",			EVASMINDENT,		&asm_indent},
	{NULL,	"bkin",					EVBKIN,				backnonbreakchar},
	{NULL,	"blink",				EVBLINK,			&blink_count},
	{NULL,	"bufhook",				EVBUFHOOK,			&bufhook},
	{NULL,	"bufnum",				EVBUFNUM,			0},
	{NULL,	"bufpos",				EVBUFPOS,			0},
	{NULL,	"cbflags",				EVCBFLAGS,			0},
#ifndef MINES
	{NULL,	"cbold",				EVCBOLD,			&cbold},
#endif
	{NULL,	"cbufdir",				EVCBUFDIR,			&cbufdir},
	{NULL,	"cbufname",				EVCBUFNAME,			0},
#ifndef MINES
	{NULL,	"ccase-buffer",			EVCCASEBUF,			&compcase[0]},
	{NULL,	"ccase-c",				EVCCASEC,			&compcase[1]},
	{NULL,	"ccase-command",		EVCCASECOM,			&compcase[2]},
	{NULL,	"ccase-filename",		EVCCASEFNAME,		&compcase[3]},
	{NULL,	"ccase-general",		EVCCASEGEN,			&compcase[4]},
	{NULL,	"ccase-keyword",		EVCCASEKEYWORD,		&compcase[5]},
	{NULL,	"ccase-latex",			EVCCASELATEX,		&compcase[6]},
	{NULL,	"ccase-macro",			EVCCASEMAC,			&compcase[7]},
	{NULL,	"ccase-mode",			EVCCASEMODE,		&compcase[8]},
	{NULL,	"ccase-var",			EVCCASEVAR,			&compcase[9]},
#endif
	{NULL,	"cfname",				EVCFNAME,			0},
#ifndef MINES
	{NULL,	"chigh",				EVCHIGH,			&chigh},
#endif
	{NULL,	"cmdarg",				EVCMDARG,			&cmdarg},
#ifndef MINES
	{NULL,	"cmdcol",				EVCMDCOL,			&cmdcol},
	{NULL,	"cmdhook",				EVCMDHK,			&cmdhook},
	{NULL,	"cmdzencol",			EVCMDZENCOL,		&cmdzencol},
#endif
	{NULL,	"cmode",				EVCMODE,			0},
#ifndef MINES
	{NULL,	"colvis",				EVCOLVIS,			&colvis},
#endif
	{NULL,	"comp-c",				EVCOMPC,			&comp_c},
	{NULL,	"comp-general",			EVCOMPGENERAL,		&comp_gene},
#ifndef MINES
	{NULL,	"comp-keyword",			EVCOMPKEYWORD,		0},
	{NULL,	"comp-keyword-set",		EVCOMPKEYWORD_SET,	0},
	{NULL,	"comp-latex",			EVCOMPLATEX,		&comp_latex},
	{NULL,	"compbuf-sort",			EVCOMPSORT,			&comp_sort},
	{NULL,	"compbuf-sort-dir",		EVCOMPSORT_DIR,		&comp_sort_dir},
	{NULL,	"compbuf-sort-ext",		EVCOMPSORT_EXT,		&comp_sort_ext},
	{NULL,	"compbuf-sort-igncase",	EVCOMPSORT_ICASE,	&comp_sort_ignore_case},
	{NULL,	"crcol",				EVCRCOL,			&crcol},
#endif
	{NULL,	"curchar",				EVCURCHAR,			0},
	{NULL,	"curcol",				EVCURCOL,			0},
	{NULL,	"curline",				EVCURLINE,			0},
	{NULL,	"current-dir",			EVCURDIR,			0},
	{NULL,	"cursor-figure",		EVCURFIG,			0},
	{NULL,	"curwidth",				EVCURWIDTH,			&term.t_ncol},
	{NULL,	"curword",				EVCURWORD,			0},
	{NULL,	"cwline",				EVCWLINE,			0},
	{NULL,	"debug",				EVDEBUG,			&macbug},
	{NULL,	"debug-system",			EVDEBUGSYS,			&debug_system},
#ifdef B_FILLCOLUMN
	{NULL,	"default-fillcol",		EVDEFFILLCOL,		&fillcol},
#endif
#ifdef B_MAKBAK
	{NULL,	"default-makbak",		EVDEFMAKBAK,		&makbak},
#endif
#ifdef B_UNIX_NEWLINE
	{NULL,	"default-unix-newline",	EVDEFNL,			&unix_newline},
#endif
#ifndef MINES
	{NULL,	"diagflag",				EVDIAGFLAG,			&diagflag},
	{NULL,	"dict-path",			EVDICTPATH,			&std_dict_path},
#endif
	{NULL,	"dired-cdflag",			EVDCDFLAG,			&dired_cd_flag},
	{NULL,	"dired-cp",				EVDCP,				&dired_cp_cmd},
	{NULL,	"dired-cfname",			EVDCFNAME,			0},
	{NULL,	"dired-current-dir",	EVDCURDIR,			dired_current_dir},
	{NULL,	"dired-ls",				EVDLS,				&dired_ls_cmd},
	{NULL,	"dired-ls-name-pos",	EVDLSNAMEPOS,		&dired_ls_name_pos},
	{NULL,	"dired-marknum",		EVDMKNUM,			&dired_mark_num},
	{NULL,	"dired-mv",				EVDMV,				&dired_mv_cmd},
	{NULL,	"dired-rm",				EVDRM,				&dired_rm_cmd},
	{NULL,	"discmd",				EVDISCMD,			&discmd},
	{NULL,	"disinp",				EVDISINP,			&disinp},
	{NULL,	"disnum",				EVDISNUM,			&disnum},
	{NULL,	"dispcr",				EVDISPCR,			&dispcr},
	{NULL,	"distab",				EVDISTAB,			&distab},
	{NULL,	"diszenspc",			EVDISZEN,			&diszen},
	{NULL,	"dostail",				EVDOSTAIL,			dostail},
#ifndef MINES
	{NULL,	"dselcol",				EVDSELCOL,			&dselcol},
	{NULL,	"edpage",				EVEDPAGE,			&edpage},
#endif
	{NULL,	"emacs-dir",			EVEMACSDIR,			&emacsdir},
#ifndef MINES
	{NULL,  "empcol",				EVEMPCOL, 	 		&empcol},
#endif
	{NULL,  "emphasis-text",		EVEMPTEXT,  		0},
#ifndef MINES
	{NULL,	"english",				EVENGLISH,			&english},
#endif
	{NULL,	"eval",					EVEVAL,				&syseval},
#ifndef MINES
	{NULL,	"exbhook",				EVEXBHOOK,			&exbhook},
#endif
	{NULL,	"exithook",				EVEXITHOOK,			&exithook},
	{NULL,	"fcol",					EVFCOL,				0},
#ifndef MINES
	{NULL,	"fep-ctrl",				EVFEPCTRL,			&fepctrl},
	{NULL,	"fep-ctrl-esc",			EVFEPCTRLESC,		&fepctrlesc},
#endif
	{NULL,	"fep-mode",				EVFEPMODE,			0},
#ifndef B_FILLCOLUMN
	{NULL,	"fillcol",				EVFILLCOL,			&fillcol},
#else
	{NULL,	"fillcol",				EVFILLCOL,			0},
#endif
	{NULL,	"fkin",					EVFKIN,				fornonbreakchar},
#ifndef MINES
	{NULL,	"flicker",				EVFLICKER,			(char *)nsupm},
#endif
	{NULL,	"forceproc",			EVFORCEP,			&forceproc},
#ifndef MINES
	{NULL,	"gflags",				EVGFLAGS,			&gflags},
#endif
	{NULL,	"gmode",				EVGMODE,			&gmode},
	{NULL,	"hardtab",				EVHARDTAB,			&tabsize},
#ifndef MINES
	{NULL,	"help-load-path",		EVHELPLPATH,		help_load_path},
#endif
	{NULL,	"hjump",				EVHJUMP,			&hjump},
	{NULL,	"hscroll",				EVHSCROLL,			&hscroll},
	{NULL,	"ifilehook",			EVIFILEHOOK,		&ifilehook},
	{NULL,	"ifilename",			EVIFILENAME,		&ifilename},
#ifndef MINES
	{NULL,	"ifsplit",				EVIFSPLIT,			&ifsplit},
#endif
	{NULL,	"ignext",				EVIGNEXT,			ignoreext},
#ifndef MINES
	{NULL,	"ignmetacase",			EVIGNMETACASE,		&ignmetacase},
#endif
	{NULL,	"ignore-backup-suffix",	EVIGNBKUPSUF,		&ignore_backup_suffix},
	{NULL,	"inshook",				EVINSHOOK,			&inshook},
#ifndef MINES
	{NULL,	"isearch-micro",		EVISEARCHMICRO,		&isearch_micro},
#endif
	{NULL,	"kill",					EVKILL,				0},
#ifndef MINES
	{NULL,	"language",				EVLANG,				0},
#endif
	{NULL,	"lastkey",				EVLASTKEY,			&lastkey},
	{NULL,	"lastmesg",				EVLASTMESG,			lastmesg},
#ifndef MINES
	{NULL,	"latexenv",				EVLATEXENV,			latex_env},
	{NULL,	"led-mode",				EVLEDMODE,			0},
#endif
	{NULL,	"line",					EVLINE,				0},
#ifndef MINES
	{NULL,	"lnumcol",				EVLNUMCOL,			&lnumcol},
	{NULL,	"lsepcol",				EVLSEPCOL,			&lsepcol},
#endif
	{NULL,	"localmap",				EVLOCALMAP,			0},
	{NULL,	"localmlform",			EVLOCALMLFORM,		0},
	{NULL,	"localtab",				EVLOCALTAB,			0},
#ifndef MINES
	{NULL,	"localvar",				EVLOCALVAR,			0},
#endif
	{NULL,	"lwidth",				EVLWIDTH,			0},
#ifndef B_MAKBAK
	{NULL,	"makbak",				EVMAKBAK,			&makbak},
#else
	{NULL,	"makbak",				EVMAKBAK,			0},
#endif
	{NULL,	"match",				EVMATCH,			0},
#ifndef MINES
	{NULL,	"menu-code",			EVMENU_CODE,		&menu_code},
	{NULL,	"menu-cursor",			EVMENU_CURSOR,		&menu_cursor},
	{NULL,	"menu-exit",			EVMENU_EXIT,		menu_exit},
	{NULL,	"menu-frame-color",		EVMENU_FRAME,		&menu_frame_color},
	{NULL,	"menu-height",			EVMENU_HEIGHT,		&menu_height},
	{NULL,	"menu-home-x",			EVMENU_HOMEX,		&menu_home_x},
	{NULL,	"menu-home-y",			EVMENU_HOMEY,		&menu_home_y},
	{NULL,	"menu-item-color",		EVMENU_ITEM,		&menu_item_color},
	{NULL,	"menu-last-key",		EVMENU_LAST_K,		&menu_last_key},
	{NULL,	"menu-quickact",		EVMENU_QUICKACT,	&menu_quickact},
	{NULL,	"menu-roll",			EVMENU_ROLL,		&menu_roll},
	{NULL,	"menu-select-color",	EVMENU_SELECT,		&menu_select_color},
	{NULL,	"menu-select-key",		EVMENU_SELECT_K,	menu_select},
	{NULL,	"menu-title",			EVMENU_TITLE,		menu_title},
	{NULL,	"menu-width",			EVMENU_WIDTH,		&menu_width},
#endif
	{NULL,	"mlform",				EVMLFORM,			mlform},
	{NULL,	"modeflag",				EVMODEFLAG,			&modeflag},
#ifndef MINES
	{NULL,	"msflag",				EVMSFLAG,			&mouseflag},
	{NULL,	"multimark-max",		EVMULMAX,			&mulmax},
	{NULL,	"newscroll",			EVNEWSCR,			&newscroll},
	{NULL,	"noglobal",				EVNOGLOBAL,			&noglobal},
#endif
	{NULL,	"nokill",				EVNOKILL,			&nokill},
#ifndef MINES
	{NULL,	"opt-swap",				EVOPTSWAP,			&optswap},
#endif
	{NULL,	"pagelen",				EVPAGELEN,			0},
#ifndef MINES
	{NULL,	"palette",				EVPALETTE,			palstr},
	{NULL,	"palette2",				EVPALETTE2,			palstr2},
#endif
	{NULL,	"pending",				EVPENDING,			0},
#ifndef MINES
	{NULL,	"pickcurrc",			EVPICKCURRC,		&pickcurrc},
#endif
	{NULL,	"progname",				EVPROGNAME,			0},
#ifndef MINES
	{NULL,	"quickact-buffer",		EVQUICKACTBUF,		&quickact[0]},
	{NULL,	"quickact-command",		EVQUICKACTCOM,		&quickact[2]},
	{NULL,	"quickact-filename",	EVQUICKACTFNAME,	&quickact[3]},
	{NULL,	"quickact-general",		EVQUICKACTGENE,		&quickact[4]},
	{NULL,	"quickact-macro",		EVQUICKACTMAC,		&quickact[7]},
	{NULL,	"quickact-mode",		EVQUICKACTMODE,		&quickact[8]},
	{NULL,	"quickact-var",			EVQUICKACTVAR,		&quickact[9]},
	{NULL,	"quickexit",			EVQUICKEXT,			&quickext},
#endif
	{NULL,	"ram",					EVRAM,				&envram},
	{NULL,	"readhook",				EVREADHK,			&readhook},
	{NULL,	"region",				EVREGION,			0},
	{NULL,	"replace",				EVREPLACE,			rpat},
	{NULL,	"rval",					EVRVAL,				&rval},
#ifndef MINES
	{NULL,	"save-modified-noask",	EVSAVEM,			&savem},
#endif
	{NULL,	"sccurcol",				EVSCCURCOL,			&sccurcol},
	{NULL,	"sccurline",			EVSCCURLINE,		&sccurline},
	{NULL,	"search",				EVSEARCH,			pat},
	{NULL,	"seed",					EVSEED,				&seed},
	{NULL,	"shbsize",				EVSHBSIZE,			&shbufsize},
	{NULL,	"simple-backup-suffix",	EVSMPLBKUPSUF,		simple_backup_suffix},
	{NULL,	"slash",				EVSLASH,			0},
	{NULL,	"softtab",				EVSOFTTAB,			&stabsize},
	{NULL,	"softtab-mode",			EVSOFTTABMODE,		&stabmode},
	{NULL,	"sres",					EVSRES,				sres},
	{NULL,	"ssave",				EVSSAVE,			&ssave},
#ifndef MINES
	{NULL,	"sscroll",				EVSSCROLL,			&sscroll},
	{NULL,	"sscroll-slow",			EVSSCROLL_SLOW,		&sscroll_slow},
#endif
	{NULL,	"syskill",				EVSYSKILL,			&syskill},
	{NULL,	"status",				EVSTATUS,			&cmdstatus},
	{NULL,	"sterm",				EVSTERM,			&sterm},
#ifndef MINES
	{NULL,	"tabcol",				EVTABCOL,			&tabcol},
#endif
	{NULL,	"target",				EVTARGET,			&curgoal},
	{NULL,	"temp",					EVTEMP,				system_temp},
#ifndef MINES
	{NULL,	"texbquote",			EVTEXBQUOTE,		texbquote},
#endif
	{NULL,	"time",					EVTIME,				0},
#ifndef MINES
	{NULL,	"tokana",				EVTOKANA,			&tokana},
#endif
	{NULL,	"tpause",				EVTPAUSE,			&term.t_pause},
#ifndef MINES
	{NULL,	"trash",				EVTRASH,			trash},
	{NULL,	"txtcol",				EVTXTCOL,			&txtcol},
#endif
#ifndef B_UNIX_NEWLINE
	{NULL,	"unix-newline",			EVUNIXNL,			&unix_newline},
#else
	{NULL,	"unix-newline",			EVUNIXNL,			0},
#endif
	{NULL,	"vbell",				EVVBELL,			&vbell},
	{NULL,	"version",				EVVERSION,			0},
#ifndef MINES
	{NULL,	"viscol",				EVVISCOL,			&viscol},
	{NULL,	"windhook",				EVWINDHOOK,			&windhook},
#endif
	{NULL,	"windnum",				EVWINDNUM,			0},
	{NULL,	"windpos",				EVWINDPOS,			0},
	{NULL,	"wline",				EVWLINE,			0},
#ifndef MINES
	{NULL,	"wrap-expand",			EVWRAPEXPAND,		&wrapexpand},
#endif
	{NULL,	"wrap-indent-head",		EVWRAPINDENTHEAD,	&wrapindenthead},
	{NULL,	"wrap-indent-item",		EVWRAPINDENTITEM,	&wrapindentitem},
	{NULL,	"wrap-item",			EVWRAPITEM,			&wrapitem},
	{NULL,	"wraphook",				EVWRAPHK,			&wraphook},
	{NULL,	"wrapmode",				EVWRAPMODE,			&breakmode},
	{NULL,	"writehook",			EVWRITEHK,			&writehook},
#ifndef MINES
	{NULL,	"xpos",					EVXPOS,				&xpos},
	{NULL,	"ypos",					EVYPOS,				&ypos},
	{NULL,	"zcursor",				EVZCURSOR,			&zcursor},
#endif
	{NULL,	NULL,					0,					NULL}
};

int nevars = sizeof(env_table) / sizeof(env_table[0]) - 1;

/*
========================================
	init_env_in_word_set
========================================
*/

void init_env_in_word_set(void)
{
	int i;
	short hashnum;
	const char *p;

	for(i = nevars - 1; i >= 0; i--) {
		for(hashnum = 0, p = env_table[i].e_name; *p; p++)
			hashnum = (hashnum * 71 + *p) & (NHASH - 1);

		env_table[i].e_next = env_head[hashnum];
		env_head[hashnum] = &env_table[i];
	}
}

/*
========================================
	env_in_word_set
========================================
*/

UENVAR *env_in_word_set(const char *name)
{
	UENVAR *env;
	short hashnum;
	const char *p;

	for(hashnum = 0, p = name; *p; p++)
		hashnum = (hashnum * 71 + *p) & (NHASH - 1);

	for(env = env_head[hashnum]; env; env = env->e_next) {
		if (*name == *env->e_name && !strcmp(name + 1, env->e_name + 1))
			return env;
	}

	return NULL;
}

/*
========================================
	create_var
========================================
*/

UVAR *create_var(const char *name)
{
	UVAR *var;
	char *vname;

	var = (UVAR *)malloc(sizeof(UVAR));
	vname = (char *)malloc(strlen(name) + 1);
	if (!var || !vname)
		return NULL;

	if (uv_tail) {
		uv_tail->u_next = var;
		uv_tail = var;
	} else
		uv_head = uv_tail = var;

	strcpy(vname, name);
	var->u_next = NULL;
	var->u_name = vname;
	var->u_value = NULL;

	{
		short hashnum;
		const char *p;

		for(hashnum = 0, p = name; *p; p++)
			hashnum = (hashnum * 71 + *p) & (NHASH - 1);

		var->u_hnext = uvar_head[hashnum];
		uvar_head[hashnum] = var;
	}

	return var;
}

/*
========================================
	var_in_word_set
========================================
*/

UVAR *var_in_word_set(const char *name)
{
	UVAR *var;
	short hashnum;
	const char *p;

	for(hashnum = 0, p = name; *p; p++)
		hashnum = (hashnum * 71 + *p) & (NHASH - 1);

	for(var = uvar_head[hashnum]; var; var = var->u_hnext) {
		if (*name == *var->u_name && !strcmp(name + 1, var->u_name + 1))
			return var;
	}

	return NULL;
}
