/*
----------------------------------------
	INPUT.C: MicroEMACS 3.10
----------------------------------------
*/

#include <stdio.h>
#include <string.h>
#include <io.h>
#include <ctype.h>

#include "estruct.h"
#include "etype.h"
#include "edef.h"
#include "elang.h"
#include "ekanji.h"
#include "ecall.h"
#include "fepctrl.h"

/*
========================================
	RCS id ̐ݒ
========================================
*/

__asm("	dc.b	'$Id: input.c,v 1.6.2.9 1996/10/09 11:07:25 sharl Exp $'\n""	even\n");

/*
========================================
	gp֐̒`
========================================
*/

static char *gtdfname(char *, int);
static int getlocation(char *, int);
static void inp_close(void);
static void inp_init(LEDIT *, char *, int, int, int, int, int);
static void inp_update(void);
static void inp_update2(int, int *, int *);
static void inp_inputchar(int);
static void inp_clear(void);
static void inp_forwdel(void);
static void inp_backdel(void);
static void inp_forwchar(void);
static void inp_backchar(void);
static void inp_topbot(void);
static void inp_toggleover(void);
static void inp_killtoeol(void);

/*
========================================
	gpϐ̒`
========================================
*/

static __pcr__ LEDIT *curep = NULL;

/*
========================================
	gR[hƂɖ߂
========================================
*/

int ectoc(int c)
{
	if (c & CTRL)
		c &= ~(CTRL | 0x40);
	if (c & SPEC)
		c &= CHARMASK;
	return c;
}

/*
========================================
	R}h𓾂
========================================
*/

char *getname(char *prompt)
{
	char *sp;

	sp = complete(prompt, 0, 0, CMP_COMMAND, NSTRING);
	return sp;
}

/*
========================================
	R}h𓾂 2
========================================
*/

NBIND *getname2(char *prompt)
{
	char *sp;

	sp = complete(prompt, 0, 0, CMP_COMMAND, NSTRING);
	return sp ? com_in_word_set(sp) : 0;
}

/*
========================================
	obt@𓾂
========================================
*/

BUFFER *getcbuf(char *prompt, char *defval, int createflag)
{
	char *sp;

	sp = complete(prompt, defval, 0, CMP_BUFFER, NBUFN);
	return sp ? bfind(sp, createflag, 0) : 0;
}

/*
--------------------------------------
	JgfBNgύX
--------------------------------------
*/

int cd(char *path)
{
	if (path[1] == ':')
		CHGDRV(upperc(*path) - 'A');
	else if (path[0] == slash)
		CHGDRV(upperc(*sysroot) - 'A');
	return chdir(path);
}

/*
========================================
	Y/N ˂
========================================
*/

int mlyesno(char *prompt)
{
	int c;
	char buf[NPAT];

	strcpy(buf, prompt);
	strcat(buf, KTEX162);
	mlwrite(buf);
	fep_off();
	c = getkey();
	fep_on();
	if (c == abortc) {
		ctrlg(FALSE, 0);
		return ABORT;
	}
	return (c == 'y' || c == 'Y') ? TRUE : FALSE;
}

/*
--------------------------------------
	JgfBNg擾
--------------------------------------
*/

char *getwd(char *buff)
{
	buff[0] = CURDRV() + 'A';
	buff[1] = ':';

	if (sysroot && toupper(*sysroot) == buff[0])
		getcwd(buff, NLINE);
	else
		getcwd(buff + _MAX_DRIVE, NLINE - (_MAX_DRIVE + 1));
	return cv_bslash_slash(add_slash_if(buff));
}

/*
========================================
	t@C𓾂
========================================
*/

char *gtfilename(char *prompt)
{
	return gtdfname(prompt, CMP_FILENAME);
}

/*
========================================
	fBNg𓾂
========================================
*/

char *gtdirname(char *prompt)
{
	return gtdfname(prompt, CMP_DIRNAME);
}

/*
========================================
	t@CAfBNg𓾂
========================================
*/

char *gtdfname(char *prompt, int type)
{
	char *sp;
	char cwd[NLINE];
	static char fwd[NLINE];
	struct NAMESTBUF namebuf;

	if (type == CMP_FILENAME) {
		if (cbufdir && *curbp->b_fname) {
			NAMESTS(curbp->b_fname, &namebuf);
			fwd[0] = namebuf.drive + 'A';
			fwd[1] = ':';
			if (sysroot && toupper(*sysroot) == fwd[0])
				strcpy(fwd, namebuf.path);
			else
				strcpy(fwd + _MAX_DRIVE, (char *) namebuf.path);
		} else
/* 			strcpy(fwd, current_dir); */
			getwd(fwd);
	} else
		getwd(fwd);
	cv_bslash_slash(add_slash_if(fwd));

	getwd(cwd);
	cd(fwd);
	sp = complete(prompt, fwd, 0, type, NFILEN);
	cd(cwd);

	if (type == CMP_DIRNAME)
		return sp;

	return sp ? (strcmp(fwd, sp) ? sp : 0) : 0;
}

/*
========================================
	O̕⊮
========================================
*/

char *complete(char *prompt, char *defval, char *str, int type, int maxlen)
{
	LEDIT	edit;
	int		quotef;
	int		inputf;
	int		his_first;
	int		quick;
	int		cpos = 0;
	static char buf[NSTRING];

	if (clexec)
		return (macarg(buf) == TRUE) ? buf : 0;

	if (kbdmode != PLAY) {
#ifndef MINES
		TXcurof();
		TXcuron();
#endif
		fep_force_off();
	}

	switch (type) {
	case CMP_BUFFER:
		his_enable(bhiscmpbufp);
		break;
	case CMP_C:
		his_enable(bhiscmpcp);
		break;
	case CMP_COMMAND:
		his_enable(bhiscmpcomp);
		break;
	case CMP_FILENAME:
		his_enable(bhiscmpfnamep);
		break;
	case CMP_GENERAL:
		his_enable(bhiscmpgenp);
		break;
#ifndef MINES
	case CMP_LATEX:
		his_enable(bhiscmplatexp);
		break;
#endif
	case CMP_MACRO:
		his_enable(bhiscmpmacp);
		break;
	case CMP_MODE:
		his_enable(bhiscmpmodep);
		break;
	case CMP_VARIABLE:
		his_enable(bhiscmpvarp);
		break;
	case CMP_DIRNAME:
		his_enable(bhiscmpdnamep);
	}

	if (prompt && kbdmode != PLAY) {
		if (type == CMP_COMMAND || type == CMP_MACRO)
			mlwrite("%s", prompt);
		else if (defval)
			mlwrite("%s[%s]: ", prompt, defval);
		else
			mlwrite("%s: ", prompt);
	}
	{
		int		home = mlgetcursor();

		*buf = 0;
		if (str) {
			int c;

			while (c = *str++)
				buf[cpos++] = c;
			buf[cpos] = 0;
			comp_general(buf, &cpos, type);
		}

		inp_init(&edit, buf, cpos, maxlen, home, TRUE, kbdmode != PLAY);
	}

	his_first = TRUE;
	quotef = 0;
	while (1) {
		int c;

		cpos = edit.pos;
		if (kbdmode != PLAY)
			inp_update();

		c = getkey();
		inputf = TRUE;

		if (iskanji(c & CHARMASK)) {
			quotef = 0;
			c = ((c & CHARMASK) << 8) + (getkey() & CHARMASK);
			inp_inputchar(c);
			continue;
		}
		if (quotef == FALSE) {
			if (c == (CTRL | 'M')) {
				if (kbdmode != PLAY) {
					cwin_close();
					his_regist(&edit);
					inp_close();
				}
				return (defval && cpos == 0) ? defval : buf;
			} else if (c == abortc || c == sterm) {
				cwin_close();
				inp_close();
				ctrlg(FALSE, 0);
				return 0;
			} else if (c == quotec1 || c == quotec2) {
				quotef = TRUE;
			} else {
				switch (c) {
#ifndef MINES
				case ALTD | 'e':
					comp_sort_ext = ~comp_sort_ext;
#endif
				case ' ':
				case CTRL | 'I':
					if (type == CMP_FILENAME || type == CMP_DIRNAME)
						cv_bslash_slash(buf);
					cpos = strlen(buf);
					quick = comp_general(buf, &cpos, type);
					edit.pos = cpos;
					edit.modified = TRUE;
					if (quick == TRUE) {
						if (kbdmode != PLAY) {
							inp_update();
							cwin_close();
							his_regist(&edit);
							inp_close();
						}
						return buf;
					}
					goto over;
				case SPEC | '#':
				case CTRL | 'P':
					his_backward(&edit, his_first);
					his_first = FALSE;
					goto over2;
				case SPEC | '!':
				case CTRL | 'N':
					his_forward(&edit, his_first);
					his_first = FALSE;
					goto over2;
				case SPEC | SHFT | '#':
					his_sc_backward(&edit, his_first);
					his_first = FALSE;
					goto over2;
				case SPEC | SHFT | '!':
					his_sc_forward(&edit, his_first);
					his_first = FALSE;
					goto over2;
				case CTRL | ']':
					if (kbdmode != PLAY)
						his_regist(&edit);
					goto over;
				case SPEC | ')':
				case CTRL | 'F':
					inp_forwchar();
					goto over;
				case SPEC | '(':
				case CTRL | 'B':
					inp_backchar();
					goto over;
				case SPEC | '%':
				case CTRL | 'D':
					inp_forwdel();
					goto over;
				case CTRL | 'H':
					inp_backdel();
					goto over;
				case CTRL | 'A':
					inp_topbot();
					goto over;
				case CTRL | 'O':
				case SPEC | '$':
					inp_toggleover();
					goto over;
				case CTRL | 'U':
				case SPEC | '=':
				case SPEC | '+':
					inp_clear();
					goto over;
				case CTRL | 'K':
					inp_killtoeol();
					goto over;
				case SPEC | '-':
				case CTRL | 'E':
					cwin_down();
					goto over;
				case SPEC | '&':
				case CTRL | 'W':
					cwin_up();
					goto over;
				case CTRL | 'C':
				case CTRL | 'V':
					cwin_rollup();
					goto over;
				case CTRL | 'R':
				case CTRL | 'Z':
					cwin_rolldown();
					goto over;
				default:
					break;
over:
				his_first = TRUE;
over2:
				inputf = FALSE;
				}
			}
		}
		if (inputf == TRUE) {
			if ((c & ~CTRL) < 0x100) {
				if (quotef == TRUE) {
					c = getkey();
					if ((c & ~CTRL) >= 0x100)
						c = 0;
					c = ectoc(c);
				} else {
					c = ectoc(c);
					if (c < ' ' && c != '\r' && c != '\n' && c != '\t')
						c = 0;
					if (c == '\r')
						c = I_NEWLINE;
				}
				if (c)
					inp_inputchar(c);
			} else {
				char	keyword[32];

				cmdstr(c, keyword);
				his_shortcut(&edit, keyword);
			}
		}
		quotef = FALSE;
	}
}

/*
========================================
	L[
========================================
*/

int tgetc(void)
{
	int c;

	if (kbdmode == PLAY) {
		if (kbdptr < kbdend)
			return ((int) *kbdptr++);
		if (--kbdrep < 1) {
			kbdmode = STOP;
			update(FALSE);
		} else {
			kbdptr = &kbdm[0];
			return ((int) *kbdptr++);
		}
	}
	c = H68getc();
	lastkey = c;
	if (kbdmode == RECORD) {
		*kbdptr++ = c;
		kbdend = kbdptr;
		if (kbdptr == &kbdm[NKBDM - 1]) {
			kbdmode = STOP;
			H68beep();
		}
	}
	return c;
}

/*
========================================
	L[ 2
========================================
*/

int getkey(void)
{
	int c;

	if (isearch_last_key) {
		c = isearch_last_key;
		isearch_last_key = 0;
		return c;
	}

	c = tgetc();
	if (c <= 0) {
		int cc;

		cc = tgetc();
		switch (c) {
#ifndef MINES
		case 0:
			if (cc & (MOUS >> 8)) {
				xpos = tgetc();
				ypos = tgetc();
			}
			goto lastgo;
#endif
		case -2:
			cc = (cc << 8) | tgetc();
		case -1:
			cc = (cc << 8) | tgetc();
#ifndef MINES
		lastgo:
#else
		case 0:
#endif
			cc = (cc << 8) | tgetc();
		}
		c = cc;
	}
	if ((c & CHARMASK) <= 0x1f)
		c = CTRL | (c + '@');

	return c;
}

/*
========================================
	R}h͏
========================================
*/

int getcmd(void)
{
	int c;
	KEYTAB *key;

	c = getkey();
	key = getbind(change_key(c));

	if (key) {
		if (key->k_ptr.fp == meta)
			c = META | getkey();
		else if (key->k_ptr.fp == cex)
			c = (c << 16) | getkey();
		c = change_key(c);
	} else {
		if ((c & ~CHARMASK) && (c & (CTRL | MOUS)) == 0)
			c = change_key(c);
	}

	return c;
}

/*
========================================
	L[͏C
========================================
*/

int change_key(int c)
{
	if (CAPS_sense()) {
		if ((c & (CTRL | MOUS)) == 0)
			c = isupper(c & CHARMASK) ? lowerc(c) : upperc(c);
	}
#ifndef MINES
	if (ignmetacase) {
		if ((c & (CTRL | MOUS)) == 0)
			c = lowerc(c);
	}
#endif

	return c;
}

/*
========================================
	
========================================
*/

int getstring(char *prompt, char *buf, int nbuf, int eolchar)
{
	LEDIT	edit;
	int		quotef;
	int		inputf;
	int		his_first;

	if (discmd && kbdmode != PLAY)
		mlwrite(prompt);
	else
		mlmovecursor(0);

	if (kbdmode != PLAY) {
#ifndef MINES
		TXcurof();
		TXcuron();
#endif
		fep_force_off();
	}

	*buf = 0;
	inp_init(&edit, buf, 0, nbuf, mlgetcursor(), TRUE, kbdmode != PLAY);

	his_first = TRUE;
	quotef = 0;
	while (1) {
		int c;

		if (kbdmode != PLAY)
			inp_update();

		c = getkey();
		inputf = TRUE;

		if (iskanji(c & CHARMASK)) {
			quotef = 0;
			c = ((c & CHARMASK) << 8) + (getkey() & CHARMASK);
			inp_inputchar(c);
			continue;
		}
		if (quotef == FALSE) {
			if (c == eolchar) {
				if (kbdmode != PLAY) {
					his_regist(&edit);
					inp_close();
					mlerase();
				}
				return *buf ? TRUE : FALSE;
			}
			if (c == abortc || c == sterm) {
				ctrlg(FALSE, 0);
				return ABORT;
			} else if (c == quotec1 || c == quotec2) {
				quotef = TRUE;
			} else {
				switch (c) {
				case SPEC | '#':
				case CTRL | 'P':
					his_backward(&edit, his_first);
					his_first = FALSE;
					goto over2;
				case SPEC | '!':
				case CTRL | 'N':
					his_forward(&edit, his_first);
					his_first = FALSE;
					goto over2;
				case SPEC | SHFT | '#':
					his_sc_backward(&edit, his_first);
					his_first = FALSE;
					goto over2;
				case SPEC | SHFT | '!':
					his_sc_forward(&edit, his_first);
					his_first = FALSE;
					goto over2;
				case CTRL | ']':
					if (kbdmode != PLAY)
						his_regist(&edit);
					goto over;
				case SPEC | ')':
				case CTRL | 'F':
					inp_forwchar();
					goto over;
				case SPEC | '(':
				case CTRL | 'B':
					inp_backchar();
					goto over;
				case SPEC | '%':
				case CTRL | 'D':
					inp_forwdel();
					goto over;
				case CTRL | 'H':
					inp_backdel();
					goto over;
				case CTRL | 'A':
					inp_topbot();
					goto over;
				case CTRL | 'O':
				case SPEC | '$':
					inp_toggleover();
					goto over;
				case CTRL | 'U':
				case SPEC | '=':
				case SPEC | '+':
					inp_clear();
					goto over;
				case CTRL | 'K':
					inp_killtoeol();
					goto over;
				default:
					break;
over:
				his_first = TRUE;
over2:
				inputf = FALSE;
				}
			}
		}
		if (inputf == TRUE) {
			if ((c & ~CTRL) < 0x100) {
				if (quotef == TRUE) {
					c = getkey();
					if ((c & ~CTRL) >= 0x100)
						c = 0;
					c = ectoc(c);
				} else {
					c = ectoc(c);
					if (c < ' ' && c != '\r' && c != '\n' && c != '\t')
						c = 0;
					if (c == '\r')
						c = I_NEWLINE;
				}
				if (c)
					inp_inputchar(c);
			} else {
				char	keyword[32];

				cmdstr(c, keyword);
				his_shortcut(&edit, keyword);
			}
		}
		quotef = FALSE;
	}
}

/*
========================================
	o1
========================================
*/

void outchar(int c)
{
	if (disinp && kbdmode != PLAY)
		mlout(c);
}

/*
========================================
	o1
========================================
*/

void outstring(char *p)
{
	if (disinp && kbdmode != PLAY) {
		while (*p)
			mlout(*p++);
	}
}

/*
========================================
	Abvf[g1
========================================
*/

void outupdate(void)
{
	if (disinp && kbdmode != PLAY)
		mlupdate();
}

/*
========================================
	o2
========================================
*/

void ochar(int c)
{
	if (discmd)
		mlout(c);
}

/*
========================================
	o2
========================================
*/

void oupdate(void)
{
	if (discmd)
		mlupdate();
}

/*
========================================
	J[\̕\ʒu𓾂
========================================
*/

static int getlocation(char *text, int pos)
{
	char	*p;
	int		i;
	int		c;
	int		loc;

	loc = 0;
	p = text;
	for(i = pos; i > 0; i--) {
		c = *p++;
		if (iskanji(c)) {
			if (c != 0x80 && c < 0xf0)
				loc++;
			loc++;
			p++;
			i--;
		} else if (c == I_NEWLINE) {
			loc += 4;
		} else if (c < 0x20) {
			loc += 2;
		} else
			loc++;
	}
	return loc;
}

/*
========================================
	inp_init
========================================
*/

static void inp_init(LEDIT *edit, char *text, int pos, int limit, int home, int insmode, int uf)
{
	{
		int		width;
		int		loc;
		int		base;

		base = 0;
		loc = getlocation(text, pos);
		width = term.t_ncol - home;
		if (width >= 6) {
			if (loc >= width - 2)
				base = -(((loc - 2) / (width - 4)) * (width - 4));
		}
		*edit = (LEDIT){text, pos, limit, insmode, home, base, uf, TRUE};
	}
	curep = edit;

	if (uf)
		inp_update();
}

/*
========================================
	inp_close
========================================
*/

static void inp_close(void)
{
	updinsf = TRUE;
}

/*
========================================
	inp_update
========================================
*/

static void inp_update(void)
{
	LEDIT	*ep = curep;
	int		len;
	int		pos;
	int		loc;
	int		base;
	char	*text;

	text = ep->text;
	pos  = ep->pos;
	len  = strlen(text);

	{
		int		width;

		base = 0;
		loc = getlocation(text, pos);
		width = term.t_ncol - ep->home;
		if (width >= 6) {
			if (loc >= width - 2)
				base = -(((loc - 2) / (width - 4)) * (width - 4));
		}
		if (ep->base != base) {
			ep->base = base;
			ep->modified = TRUE;
		}
	}
	if (ep->modified == TRUE) {
		char	*p = text;
		int		col = base;
		int		c;
		int		kanji;

		mlmove(ep->home);

		kanji = 0;
		while (c = *p++) {
			if (c == I_NEWLINE) {
				char	*q = "<NL>";
				int		c;

				while (c = *q++)
					inp_update2(c, &col, &kanji);
			} else if (c < ' ') {
				inp_update2('^', &col, &kanji);
				inp_update2(c + '@', &col, &kanji);
			} else
				inp_update2(c, &col, &kanji);
		}
		mldeltoeol();
		mlmovecursor(ep->home + base + loc);
		outupdate();
		ep->modified = FALSE;
	}
	if (ep->chg_insmode) {
		K_INSMOD(ep->insmode ? 0xff : 0x00);
		ep->chg_insmode = FALSE;
		if (*inshook) {
			int save;
			char tmp[NBUFN];

			strcpy(tmp, ep->insmode ? "2 " : "1 ");
			strcat(tmp, inshook);
			save = macbug;
			macbug = FALSE;
			exechook(tmp);
			macbug = save;
		}
	}
	mlmovecursor(ep->home + base + loc);
	H_CURON();
}

/*
========================================
	inp_update2
========================================
*/

static void inp_update2(int c, int *pos, int *kanji)
{
	int		width;
	int		_pos = *pos;
	int		_kanji = *kanji;

	width = term.t_ncol - curep->home;

	if (_kanji) {
		int		size;

		c = (_kanji << 8) + c;
		size = (_kanji != 0x80 && _kanji < 0xf0) ? 2 : 1;
		*kanji = 0;

		if (_pos == 0 && curep->base < 0 || _pos == -1 && size == 2) {
			outchar('$');
			if (_pos == 0 && size == 2)
				outchar(' ');
		} else if (_pos >= 0 && _pos < width) {
			if (_pos + size <= width)
				outchar(c);
			else
				outchar('$');
		} else if (_pos >= width) {
			if (_pos == width)
				outstring("\b$");
		}
		(*pos) += size;
	} else {
		if (iskanji(c)) {
			*kanji = c;
			return;
		}
		if (_pos == 0 && curep->base < 0)
			outchar('$');
		else if (_pos == width)
			outstring("\b$");
		else if (_pos >= 0 && _pos < width)
			outchar(c);
		(*pos)++;
	}
}

/*
========================================
	inp_inpchar
========================================
*/

static void inp_inputchar(int c)
{
	LEDIT	*ep = curep;
	int		len;
	int		pos;
	int		limit;
	char	*text;

	text  = ep->text;
	pos   = ep->pos;
	limit = ep->limit;
	len   = strlen(text);

	if (ep->insmode == FALSE) {
		if (c > 0xff && !iskanji(text[pos]) && len == limit)
			return;
		inp_forwdel();
	}
	{
		int		csize;

		csize = (c > 0xff) ? 2 : 1;
		if (len + csize >= limit)
			return;

		{
			char	*p, *q;
			int		i;

			p = text + len;
			q = p + csize;
			for(i = len - pos; i >= 0; i--)
				*q-- = *p--;
		}

		if (csize == 2)
			text[pos++] = (c >> 8) & CHARMASK;
		text[pos] = c & CHARMASK;

		ep->pos += csize;
		ep->modified = TRUE;
	}
}

/*
========================================
	inp_clear
========================================
*/

static void inp_clear(void)
{
	LEDIT	*ep = curep;

	ep->pos = 0;
	ep->text[0] = 0;
	ep->modified = TRUE;
}

/*
========================================
	inp_forwdel
========================================
*/

static void inp_forwdel(void)
{
	LEDIT	*ep = curep;
	int		pos;
	char	*text;

	text = ep->text;
	pos  = ep->pos;

	if (text[pos] == 0)
		return;

	inp_forwchar();
	inp_backdel();
}

/*
========================================
	inp_backdel
========================================
*/

static void inp_backdel(void)
{
	LEDIT	*ep = curep;
	int		pos;
	char	*text;

	text = ep->text;
	pos  = ep->pos;

	if (pos == 0)
		return;

	{
		int		csize;

		csize = (nthctype(text, pos) == CT_KJ2) ? 2 : 1;
		{
			char	*p, *q;

			p = text + pos;
			q = p - csize;
			while (*q++ = *p++);
		}
		ep->pos -= csize;
		ep->modified = TRUE;
	}
}

/*
========================================
	inp_forwchar
========================================
*/

static void inp_forwchar(void)
{
	LEDIT	*ep = curep;
	int		pos;
	int		c;
	char	*text;

	text = ep->text;
	pos  = ep->pos;

	c = text[pos];
	if (c == 0)
		return;

	ep->pos += iskanji(c) ? 2 : 1;
}

/*
========================================
	inp_backchar
========================================
*/

static void inp_backchar(void)
{
	LEDIT	*ep = curep;
	int		pos;
	char	*text;

	text = ep->text;
	pos  = ep->pos;

	if (pos == 0)
		return;

	ep->pos -= (nthctype(text, pos) == CT_KJ2) ? 2 : 1;
}

/*
========================================
	inp_killtoeol
========================================
*/

static void inp_killtoeol(void)
{
	LEDIT	*ep = curep;
	int		pos;
	char	*text;

	text = ep->text;
	pos  = ep->pos;

	text[pos] = 0;

	ep->modified = TRUE;
}

/*
========================================
	inp_topbot
========================================
*/

static void inp_topbot(void)
{
	LEDIT	*ep = curep;
	int		pos;
	char	*text;

	text = ep->text;
	pos  = ep->pos;

	ep->pos = pos ? 0 : strlen(text);
}

/*
========================================
	inp_toggleover
========================================
*/

static void inp_toggleover(void)
{
	LEDIT	*ep = curep;

	ep->insmode = ep->insmode ? FALSE : TRUE;
	ep->chg_insmode = TRUE;
}
