/*
----------------------------------------
	LINE.C: MicroEMACS 3.10
----------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "estruct.h"
#include "etype.h"
#include "edef.h"
#include "elang.h"
#include "ekanji.h"
#include "ecall.h"

/*
========================================
	RCS id ̐ݒ
========================================
*/

__asm("	dc.b	'$Id: line.c,v 1.3.1.6 1996/08/16 10:19:17 sharl Exp $'\n""	even\n");

/*
========================================
	gp֐̒`
========================================
*/

static int ldelnewline(void);
static void swap_kbf(void);
static void syskillchk(void);

/*
========================================
	gpϐ̒`
========================================
*/

static __pcr__ KILL *kbufp = 0;
static __pcr__ KILL *kbufh2 = 0;
static __pcr__ KILL *kbufp2 = 0;

/*
========================================
	kill buffer  swap
========================================
*/

static void swap_kbf(void)
{
	int tmpkud;
	KILL *tmpkbh, *tmpkbp;

	tmpkbh = kbufh;
	tmpkbp = kbufp;
	tmpkud = kused;
	kbufh = kbufh2;
	kbufp = kbufp2;
	kused = kused2;
	kbufh2 = tmpkbh;
	kbufp2 = tmpkbp;
	kused2 = tmpkud;
}

/*
========================================
	system-kill-buffer ̓ꊷ
========================================
*/

static void syskillchk(void)
{
	if (syskillflg != syskill) {
		swap_kbf();
		syskillflg = syskill;
	}
}

/*
========================================
	sm
========================================
*/

LINE *lalloc(int used)
{
	LINE *lp;

	lp = (LINE *) malloc(sizeof(LINE) + used);
	if (lp == 0) {
		mlwrite(KTEX99);
		return 0;
	}
	lp->l_size = used;
	lp->l_used = used;
	return lp;
}

/*
========================================
	sg
========================================
*/

LINE *lrealloc(LINE *lp, int used)
{
	LINE *newlp;

	newlp = (LINE *) realloc(lp, sizeof(LINE) + used);
	if (newlp == 0) {
		mlwrite(KTEX99);
		return 0;
	}
	newlp->l_size = used;
	newlp->l_used = used;
	return newlp;
}

/*
========================================
	s
========================================
*/

void lfree(LINE *lp)
{
	LINE *next = lforw(lp);

	{
		WINDOW *wp;

		for (wp = wheadp; wp; wp = wp->w_wndp) {
			int i;

			if (wp->w_linep == lp)
				wp->w_linep = next;
			if (wp->w_dotp == lp) {
				wp->w_dotp = next;
				wp->w_doto = 0;
			}
			{
				LINE **mp;

				for (mp = wp->w_markp, i = 0; i < NMARKS; i++, mp++) {
					if (*mp == lp) {
						*mp = next;
						wp->w_marko[i] = 0;
					}
				}
			}
		}
	}

	{
		BUFFER *bp;

		for (bp = bheadp; bp; bp = bp->b_bufp) {
			int i;

			if (bp->b_dotp == lp) {
				bp->b_dotp = next;
				bp->b_doto = 0;
			}
			{
				LINE **mp;

				for (mp = bp->b_markp, i = 0; i < NMARKS; i++, mp++) {
					if (*mp == lp) {
						*mp = next;
						bp->b_marko[i] = 0;
					}
				}
			}
		}
	}

	lp->l_bp->l_fp = next;
	lp->l_fp->l_bp = lback(lp);

	free(lp);
}

/*
========================================
	sύX
========================================
*/

void lchange(int flag)
{
	BUFFER *bp = curbp;

	if (!intercept_flag && (clexec || kbdmode == PLAY))
		flag = WFHARD;
	if ((bp->b_flag & BFCHG) == 0) {
		flag |= WFMODE;
		bp->b_flag |= BFCHG;
	}

	{
		WINDOW *wp;

		for (wp = wheadp; wp; wp = wp->w_wndp) {
			if (wp->w_bufp == bp)
				wp->w_flag |= flag;
		}
	}
}

/*
----------------------------------------
	󔒂܂Ƃ߂
----------------------------------------
*/

int justonespc(int f, int n)
{
	LINE *dotp;
	int start;
	int used, doto;
	char c, *line;

	dotp = curwp->w_dotp;
	doto = curwp->w_doto;
	if (llength(dotp) == doto)
		return TRUE;
	line = dotp->l_text;
	used = dotp->l_used;

	c = line[doto];
	if (c == ' ' || c == '\t') {
		while (doto >= 0 && ((c = line[doto]) == ' ' || c == '\t'))
			doto--;
		doto += 2;
		start = doto;
		while (used > doto && ((c = line[doto]) == ' ' || c == '\t'))
			doto++;
		line[start - 1] = ' ';
		curwp->w_doto = start;
		ldelete(doto - start , 0);
	}
	lchange(WFEDIT);

	return TRUE;
}

/*
----------------------------------------
	󔒑}
----------------------------------------
*/

int insspace(int f, int n)
{
	linsert(n, ' ');
	backchar(f, n);
	return TRUE;
}

/*
========================================
	}
========================================
*/

int linstr(char *instr)
{
	int status = TRUE;

	if (instr) {
		int c;

		while ((c = *instr++) && status == TRUE) {
			status = (c == I_NEWLINE) ? lnewline() : linsert(1, c);
			if (status != TRUE) {
				mlwrite(KTEX168);
				break;
			}
		}
	}
	return status;
}

/*
========================================
	𕡐}
========================================
*/

int linsert(int n, char c)
{
	WINDOW *wp = curwp;

	if (c == ' ' && n >= 0 && check_wrap())
		exechook(wraphook);

	{
		LINE *lp1 = wp->w_dotp;
		LINE *lp2;
		int doto = wp->w_doto;

		if (lp1 == curbp->b_linep) {
			LINE *lp3;

			if (wp->w_doto > 0) {
				mlwrite(KTEX170);
				return FALSE;
			}
			lp2 = lalloc(BSIZE(n));
			if (lp2 == 0)
				return FALSE;
			lp2->l_used = n;
			lp3 = lp1->l_bp;
			lp3->l_fp = lp2;
			lp2->l_fp = lp1;
			lp1->l_bp = lp2;
			lp2->l_bp = lp3;

			memset(lp2->l_text, c, n);
			lchange(WFEDIT);
		} else {
			if (lp1->l_used + n > lp1->l_size) {
				char *cp1, *cp2;

				lp2 = lalloc(BSIZE(lp1->l_used + n));
				if (lp2 == 0)
					return FALSE;
				lp2->l_used = lp1->l_used + n;
				cp1 = lp1->l_text;
				cp2 = lp2->l_text;
				while (cp1 != lp1->l_text + doto)
					*cp2++ = *cp1++;
				cp2 += n;
				while (cp1 != lp1->l_text + lp1->l_used)
					*cp2++ = *cp1++;
				lp1->l_bp->l_fp = lp2;
				lp2->l_fp = lp1->l_fp;
				lp1->l_fp->l_bp = lp2;
				lp2->l_bp = lp1->l_bp;
				free(lp1);
			} else {
				char *cp1, *cp2;

				lp2 = lp1;
				lp2->l_used += n;
				cp2 = lp1->l_text + lp1->l_used;
				cp1 = cp2 - n;
				while (cp1 != lp1->l_text + doto)
					*--cp2 = *--cp1;
			}

			memset(lp2->l_text + doto, c, n);
			lchange(WFEDIT);
		}

		{
			BUFFER *bp;
			int i;

			bp = curbp;

			if (bp->b_dotp == lp1) {
				bp->b_dotp = lp2;
				if (bp->b_doto >= doto)
					bp->b_doto += n;
			}
			for (i = 0; i < NMARKS; i++) {
				if (bp->b_markp[i] == lp1) {
					bp->b_markp[i] = lp2;
					if (bp->b_marko[i] > doto)
						bp->b_marko[i] += n;
				}
			}
		}
		for (wp = wheadp; wp; wp = wp->w_wndp) {
			int i;

			if (wp->w_linep == lp1)
				wp->w_linep = lp2;
			if (wp->w_dotp == lp1) {
				wp->w_dotp = lp2;
				if (wp == curwp || wp->w_doto >= doto)
					wp->w_doto += n;
			}
			for (i = 0; i < NMARKS; i++) {
				if (wp->w_markp[i] == lp1) {
					wp->w_markp[i] = lp2;
					if (wp->w_marko[i] > doto)
						wp->w_marko[i] += n;
				}
			}
		}
	}

	return TRUE;
}

/*
========================================
	㏑
========================================
*/

int lowrite(char c)
{
	WINDOW *wp = curwp;

	if (wp->w_doto < wp->w_dotp->l_used
	    && (lgetc(wp->w_dotp, wp->w_doto) != TAB
		|| ((wp->w_doto) % wp->w_bufp->b_tabs == wp->w_bufp->b_tabs - 1)))
		ldelete(1, FALSE);

	return linsert(1, c);
}

/*
========================================
	㏑
========================================
*/

int lover(char *ostr)
{
	int status = TRUE;

	if (ostr) {
		int c;

		while ((c = *ostr++) && status == TRUE) {
			status = (c == I_NEWLINE) ? lnewline() : lowrite(c);
			if (status != TRUE) {
				mlwrite(KTEX172);
				break;
			}
		}
	}
	return status;
}

/*
========================================
	󔒍s}
========================================
*/

int lnewline(void)
{
	WINDOW *wp = curwp;

	lchange(WFHARD);

	{
		int doto = wp->w_doto;
		LINE *lp2, *lp1 = wp->w_dotp;

		lp2 = lalloc(doto);
		if (lp2 == 0)
			return FALSE;

		{
			char *cp1, *cp2;

			cp1 = lp1->l_text;
			cp2 = lp2->l_text;
			while (cp1 != lp1->l_text + doto)
				*cp2++ = *cp1++;
			cp2 = lp1->l_text;
			while (cp1 != lp1->l_text + llength(lp1))
				*cp2++ = *cp1++;
		}

		lp1->l_used -= doto;
		lp2->l_bp = lp1->l_bp;
		lp1->l_bp = lp2;
		lp2->l_bp->l_fp = lp2;
		lp2->l_fp = lp1;

		{
			BUFFER *bp;
			int i;

			bp = curbp;

			if (bp->b_dotp == lp1) {
				if (bp->b_doto < doto)
					bp->b_dotp = lp2;
				else
					bp->b_doto -= doto;
			}
			for (i = 0; i < NMARKS; i++) {
				if (bp->b_markp[i] == lp1) {
					if (bp->b_marko[i] < doto)
						bp->b_markp[i] = lp2;
					else
						bp->b_marko[i] -= doto;
				}
			}
		}
		for (wp = wheadp; wp; wp = wp->w_wndp) {
			int i;

			if (wp->w_linep == lp1)
				wp->w_linep = lp2;
			if (wp->w_dotp == lp1) {
				if (wp->w_doto < doto)
					wp->w_dotp = lp2;
				else
					wp->w_doto -= doto;
			}
			for (i = 0; i < NMARKS; i++) {
				if (wp->w_markp[i] == lp1) {
					if (wp->w_marko[i] < doto)
						wp->w_markp[i] = lp2;
					else
						wp->w_marko[i] -= doto;
				}
			}
		}
	}

	return TRUE;
}

/*
========================================
	폜
========================================
*/

int ldelete(int n, int kflag)
{
	while (n) {
		LINE *dotp;
		int doto, chunk;

		dotp = curwp->w_dotp;
		doto = curwp->w_doto;
		if (dotp == curbp->b_linep)
			return FALSE;

		chunk = dotp->l_used - doto;
		if (chunk > n)
			chunk = n;
		if (chunk == 0) {
			lchange(WFHARD);
			if (ldelnewline() == FALSE
			    || (kflag != FALSE && kinsert(I_NEWLINE) == FALSE))
				return FALSE;
			n--;
			continue;
		}
		lchange(WFEDIT);

		{
			char *cp1, *cp2;

			cp1 = dotp->l_text + doto;
			cp2 = cp1 + chunk;
			if (kflag != FALSE) {
				while (cp1 != cp2) {
					if (kinsert(*cp1++) == FALSE)
						return FALSE;
				}
				cp1 = dotp->l_text + doto;
			}
			while (cp2 != dotp->l_text + dotp->l_used)
				*cp1++ = *cp2++;
			dotp->l_used -= chunk;
		}

		{
			BUFFER *bp;
			int i;

			bp = curbp;

			if (bp->b_dotp == dotp && bp->b_doto >= doto) {
				bp->b_doto -= chunk;
				if (bp->b_doto < doto)
					bp->b_doto = doto;
			}
			for (i = 0; i < NMARKS; i++) {
				if (bp->b_markp[i] == dotp && bp->b_marko[i] >= doto) {
					bp->b_marko[i] -= chunk;
					if (bp->b_marko[i] < doto)
						bp->b_marko[i] = doto;
				}
			}
		}
		{
			WINDOW *wp;

			for (wp = wheadp; wp; wp = wp->w_wndp) {
				int i;

				if (wp->w_dotp == dotp && wp->w_doto >= doto) {
					wp->w_doto -= chunk;
					if (wp->w_doto < doto)
						wp->w_doto = doto;
				}
				for (i = 0; i < NMARKS; i++) {
					if (wp->w_markp[i] == dotp && wp->w_marko[i] >= doto) {
						wp->w_marko[i] -= chunk;
						if (wp->w_marko[i] < doto)
							wp->w_marko[i] = doto;
					}
				}
			}
		}

		n -= chunk;
	}

	return TRUE;
}

/*
========================================
	s̕𓾂
========================================
*/

char *getctext(void)
{
	int size;
	char *sp, *dp;
	static char rline[NSTRING];

	size = curwp->w_dotp->l_used;
	if (size >= NSTRING)
		size = NSTRING - 1;

	sp = curwp->w_dotp->l_text;
	dp = rline;
	while (size--)
		*dp++ = *sp++;
	*dp = 0;
	return rline;
}

/*
========================================
	Vsɑ}
========================================
*/

int putctext(char *iline)
{
	int status;

	curwp->w_doto = 0;
	if (llength(curwp->w_dotp)) {
		int old_nokill = nokill;

		nokill = TRUE;
		status = killtext(FALSE, 1);
		nokill = old_nokill;
		if (status != TRUE)
			return status;
	}
	return linstr(iline);
}

/*
========================================
	Vs폜
========================================
*/

static int ldelnewline(void)
{
	LINE *lp1, *lp2;

	lp1 = curwp->w_dotp;
	lp2 = lp1->l_fp;
	if (lp2 == curbp->b_linep) {
		if (lp1->l_used == 0)
			lfree(lp1);
		return TRUE;
	}
	if (lp2->l_used <= lp1->l_size - lp1->l_used) {
		{
			char *cp1, *cp2;

			cp1 = lp1->l_text + lp1->l_used;
			cp2 = lp2->l_text;
			while (cp2 != lp2->l_text + lp2->l_used)
				*cp1++ = *cp2++;
		}

		{
			BUFFER *bp;
			int i;

			bp = curbp;

			if (bp->b_dotp == lp2) {
				bp->b_dotp = lp1;
				bp->b_doto += lp1->l_used;
			}
			for (i = 0; i < NMARKS; i++) {
				if (bp->b_markp[i] == lp2) {
					bp->b_markp[i] = lp1;
					bp->b_marko[i] += lp1->l_used;
				}
			}
		}
		{
			WINDOW *wp;

			for (wp = wheadp; wp; wp = wp->w_wndp) {
				int i;

				if (wp->w_linep == lp2)
					wp->w_linep = lp1;
				if (wp->w_dotp == lp2) {
					wp->w_dotp = lp1;
					wp->w_doto += lp1->l_used;
				}
				for (i = 0; i < NMARKS; i++) {
					if (wp->w_markp[i] == lp2) {
						wp->w_markp[i] = lp1;
						wp->w_marko[i] += lp1->l_used;
					}
				}
			}
		}

		lp1->l_used += lp2->l_used;
		lp1->l_fp = lp2->l_fp;
		lp2->l_fp->l_bp = lp1;
		free(lp2);
		return TRUE;
	} else {
		LINE *lp3;

		lp3 = lalloc(lp1->l_used + lp2->l_used);
		if (lp3 == 0)
			return FALSE;

		{
			char *cp1, *cp2;

			cp1 = lp1->l_text;
			cp2 = lp3->l_text;
			while (cp1 != lp1->l_text + lp1->l_used)
				*cp2++ = *cp1++;
			cp1 = lp2->l_text;
			while (cp1 != lp2->l_text + lp2->l_used)
				*cp2++ = *cp1++;
			lp1->l_bp->l_fp = lp3;
			lp3->l_fp = lp2->l_fp;
			lp2->l_fp->l_bp = lp3;
			lp3->l_bp = lp1->l_bp;
		}

		{
			BUFFER *bp;
			int i;

			bp = curbp;

			if (bp->b_dotp == lp1)
				bp->b_dotp = lp3;
			else if (bp->b_dotp == lp2) {
				bp->b_dotp = lp3;
				bp->b_doto += lp1->l_used;
			}
			for (i = 0; i < NMARKS; i++) {
				if (bp->b_markp[i] == lp1)
					bp->b_markp[i] = lp3;
				else if (bp->b_markp[i] == lp2) {
					bp->b_markp[i] = lp3;
					bp->b_marko[i] += lp1->l_used;
				}
			}
		}
		{
			WINDOW *wp;

			for (wp = wheadp; wp; wp = wp->w_wndp) {
				int i;

				if (wp->w_linep == lp1 || wp->w_linep == lp2)
					wp->w_linep = lp3;
				if (wp->w_dotp == lp1)
					wp->w_dotp = lp3;
				else if (wp->w_dotp == lp2) {
					wp->w_dotp = lp3;
					wp->w_doto += lp1->l_used;
				}
				for (i = 0; i < NMARKS; i++) {
					if (wp->w_markp[i] == lp1)
						wp->w_markp[i] = lp3;
					else if (wp->w_markp[i] == lp2) {
						wp->w_markp[i] = lp3;
						wp->w_marko[i] += lp1->l_used;
					}
				}
			}
		}
	}

	free(lp1);
	free(lp2);

	return TRUE;
}

/*
========================================
	Lobt@폜
========================================
*/

void kdelete(void)
{
	syskillchk();

	if (kbufh && nokill == FALSE) {
		KILL *kfp = kbufh;

		while (kfp) {
			KILL *kp;

			kp = kfp->d_next;
			free(kfp);
			kfp = kp;
		}
		kbufh = kbufp = 0;
		kused = KBLOCK;
	}
}

/*
----------------------------------------
	Lobt@̍폜iR}hj
----------------------------------------
*/

int delkbuf(int f, int n)
{
	kdelete();
	return TRUE;
}

/*
========================================
	Lobt@}
========================================
*/

int kinsert(char c)
{
	syskillchk();

	if (nokill == FALSE) {
		if (kused >= KBLOCK) {
			KILL *nchunk;

			nchunk = (KILL *) malloc(sizeof(KILL));
			if (nchunk == 0)
				return FALSE;
			if (kbufh == 0)
				kbufh = nchunk;
			if (kbufp)
				kbufp->d_next = nchunk;
			kbufp = nchunk;
			kbufp->d_next = 0;
			kused = 0;
		}
		kbufp->d_chunk[kused++] = c;
	}
	return TRUE;
}

/*
----------------------------------------
	y[Xg
----------------------------------------
*/

int yank(int f, int n)
{
	char ybuf[2048];

	syskillchk();

	if (kbufh == 0)
		return TRUE;

	while (n--) {
		int crs = 0;
		char *sp, *ecp, *scp = 0, *tcp = 0;
		KILL *kp;

		for (kp = kbufh; kp; kp = kp->d_next) {
			int i = kp->d_next ? KBLOCK : kused;

			for (sp = kp->d_chunk; i--; sp++) {
				if (*sp == I_NEWLINE) {
					if (crs == 0)
						scp = sp;
					crs++;
					tcp = sp;
				}
			}
		}

		ecp = tcp;
		kp = kbufh;

		if (crs == 0 || scp == ecp) {
			for (; kp; kp = kp->d_next) {
				int i = kp->d_next ? KBLOCK : kused;

				for (sp = kp->d_chunk; i--; sp++) {
					int c;

					c = *sp;
					if (c == I_NEWLINE) {
						if (lnewline() == FALSE)
							return FALSE;
					} else {
						if (linsert(1, c) == FALSE)
							return FALSE;
					}
				}
			}
		} else {
			int i, j;

			for (;; kp = kp->d_next) {
				i = kp->d_next ? KBLOCK : kused;
				for (sp = kp->d_chunk; i--; sp++) {
					if (sp == scp) {
						if (lnewline() == FALSE)
							return FALSE;
						j = 0;
						goto next_step;
					} else {
						if (linsert(1, *sp) == FALSE)
							return FALSE;
					}
				}
			}
			for (;; kp = kp->d_next) {
				i = kp->d_next ? KBLOCK : kused;
				for (sp = kp->d_chunk; i--; sp++) {
					int c;

					c = *sp;
					if (c == I_NEWLINE) {
						ybuf[j] = 0;
						if (putline(ybuf) == FALSE)
							return FALSE;
						j = 0;
						if (sp == ecp)
							goto last_step;
					} else
						ybuf[j++] = c;

				      next_step:;
				}
			}
			for (; kp; kp = kp->d_next) {
				i = kp->d_next ? KBLOCK : kused;
				for (sp = kp->d_chunk; i--; sp++) {
					if (linsert(1, *sp) == FALSE)
						return FALSE;

				      last_step:;
				}
			}
		}
	}

	return TRUE;
}

/*
========================================
	sǉ
========================================
*/

int putline(char *text)
{
	int ntext;
	LINE *lpc;

	ntext = strlen(text);
	lpc = lalloc(BSIZE(ntext));
	if (lpc == 0)
		return FALSE;
	lpc->l_used = ntext;

	memcpy(lpc->l_text, text, ntext);

	{
		LINE *lpf, *lpb;

		lpf = curwp->w_dotp;
		lpb = lpf->l_bp;
		lpb->l_fp = lpc;
		lpc->l_bp = lpb;
		lpf->l_bp = lpc;
		lpc->l_fp = lpf;
	}

	return TRUE;
}
