/*
----------------------------------------
	MISC.C: MicroEMACS 3.10
----------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "estruct.h"
#include "etype.h"
#include "edef.h"
#include "elang.h"

/*
========================================
	RCS id ̐ݒ
========================================
*/

__asm("	dc.b	'$Id: misc.c,v 1.16 1996/10/09 17:02:03 sharl Exp $'\n" "	even\n");

/*
----------------------------------------
	t񌟍
----------------------------------------
*/
static char *
strristr(char *src, char *pat)
{
	int match_len = strlen(pat);
	char *p = src + strlen(src) - 1, ppat = tolower(*pat);

	for (;;) {
		if (tolower(*p) == ppat)
			if (!strnicmp(p, pat, match_len))
				break;
		if (p == src)
			return NULL;
		--p;
	}
	return p;
}

/*
========================================
	obt@̃`FbN
========================================
*/
int
name_check(char *bname)
{
	char *p, *q, tail[NSTRING];

	for (q = dostail; *q; q++) {
		for (p = tail; *q && !isspace(*q) && *q != ';';)
			*p++ = *q++;
		*p = '\0';
		if (strristr(bname, tail))
			return FALSE;
	}
	return TRUE;
}

/*
----------------------------------------
	switch-zcursor
----------------------------------------
*/
#ifndef MINES
int
swzcursor(int f, int n)
{
	TXcurof();
	zcursor = (zcursor + 1) % 3;
	if (zcursor > 0)
		TXcuron();
	return TRUE;
}
#endif
/*
----------------------------------------
	toggle-scroll-speed
----------------------------------------
*/
#ifndef MINES
int
togglescrollspeed(int f, int n)
{
	sscroll_slow = (sscroll_slow != FALSE)
	? (mlwrite(KTEX400), FALSE)
	: (mlwrite(KTEX401), TRUE);
	return TRUE;
}
#endif
/*
----------------------------------------
	toggle-tab-disp
----------------------------------------
*/

int
toggletabdisp(int f, int n)
{
	distab = (distab != FALSE)
	? (mlwrite(KTEX410), FALSE)
	: (mlwrite(KTEX411), TRUE);
	upwind();
	return TRUE;
}

/*
----------------------------------------
	toggle-unix-newline
----------------------------------------
*/

int
toggleunix(int f, int n)
{
#ifdef B_UNIX_NEWLINE
	if (name_check(curbp->b_bname)) {
		curbp->b_unix_newline = !curbp->b_unix_newline;
		upmode();
	}
#else
	unix_newline = (unix_newline != FALSE)
	? (mlwrite(KTEX440), FALSE)
	: (mlwrite(KTEX441), TRUE);
#endif
	return TRUE;
}

/*
----------------------------------------
	toggle-wrap-expand
----------------------------------------
*/
#ifndef MINES
int
togglewrap(int f, int n)
{
	wrapexpand = (wrapexpand != FALSE)
	? (mlwrite(KTEX430), FALSE)
	: (mlwrite(KTEX431), TRUE);
	return TRUE;
}
#endif
/*
----------------------------------------
	toggle-zenspc-disp
----------------------------------------
*/

int
togglezenspc(int f, int n)
{
	diszen = (diszen != FALSE)
	? (mlwrite(KTEX420), FALSE)
	: (mlwrite(KTEX421), TRUE);
	upwind();
	return TRUE;
}

/*
----------------------------------------
	insert-time
----------------------------------------
*/

int
itime(int f, int n)
{
	return linstr(timeset());
}

/*
----------------------------------------
	reset-replace-string
----------------------------------------
*/

int
resetrpat(int f, int n)
{
	*rpat = '\0';
	mlwrite(KTEX450);
	return TRUE;
}

/*
----------------------------------------
	save-some-buffers
----------------------------------------
*/

int
savemodified(int f, int n)
{
	BUFFER *bp, *oldbp = curbp;
	int count = 0;
#ifndef MINES
	int save = FALSE;
#endif

	savelayout(FALSE, 1);
	for (bp = bheadp; bp; bp = bp->b_bufp) {
		if (*bp->b_fname && (bp->b_flag & BFCHG) && (bp->b_flag & BFINVS) == 0) {
			int status;

#ifndef MINES
			if (f == savem) {
				char prompt[NSTRING];

				sprintf(prompt, "%s Z[u܂", bp->b_fname);
				switch(status = mlyesno(prompt)){
					case ABORT:
						return FALSE;
					default:
						save = status;
						break;
				}
			} else
				save = TRUE;

			if (save) {
#endif
				mlwrite("saving %s ...", bp->b_fname);
				swbuffer(bp, TRUE);
				status = filesave(FALSE, 1);
				if (status)
					count++;
#ifndef MINES
			}
#endif
		}
	}
	swbuffer(oldbp, TRUE);
	recoverlayout(FALSE, 1);
	switch (count) {
		case 0:
			mlwrite("No file saved.");
			break;
		case 1:
			mlwrite("A file saved.");
			break;
		default:
			mlwrite("%d files saved.", count);
	}
	return TRUE;
}

/*
----------------------------------------
	sleep
----------------------------------------
*/

int
esleep(int f, int n)
{
	if (f == FALSE) {
		int status;
		char arg[NSTRING];

		his_disable();
		status = mlreply(KTEX460, arg, NSTRING);
		if (status == ABORT) {
			mlwrite(KTEX8);
			return status;
		}
		n = asc_int(arg);
	}
	if (n < 1) {
		mlwrite(KTEX61);
		return FALSE;
	}
	sleep(n);
	return TRUE;
}

/*
----------------------------------------
	insert-variable
----------------------------------------
*/

int
ivar(int f, int n)
{
	char var[NVSIZE + 1];

	if (f == FALSE) {
		char *varp;

		varp = complete(KTEX51, 0, 0, CMP_VARIABLE, NVSIZE + 1);
		if (varp == 0)
			return FALSE;
		strcpy(var, varp);
		if (*var == '$')
			return linstr(gtenv(var + 1));
		else {
			UVAR *vp;

			vp = var_in_word_set(var + 1);
			if (vp)
				return linstr(vp->u_value);
		}
	}
	return FALSE;
}

/*
----------------------------------------
	obNAbvt@C?
----------------------------------------
*/

int
isbkupsuf(char *name)
{
	if (ignore_backup_suffix && *simple_backup_suffix)
		if (!stricmp(name + strlen(name) - strlen(simple_backup_suffix), simple_backup_suffix))
			return TRUE;
	return FALSE;
}
